// FileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FileDlg.h"
#include "afxdialogex.h"


// CFileDlg dialog

IMPLEMENT_DYNAMIC(CFileDlg, CDialogEx)

CFileDlg::CFileDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_DLGFILE, pParent)
{
}

CFileDlg::~CFileDlg()
{
}

void CFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STC_FRAME, m_fraPreview);
	DDX_Control(pDX, IDC_STC_FRABITMAP, m_fraBitmap);
}


BEGIN_MESSAGE_MAP(CFileDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BTN_SELECT, &CFileDlg::OnBnClickedSelectFile)
	ON_BN_CLICKED(IDC_BTN_CLOSE, &CFileDlg::OnBnClickedBtnClose)
END_MESSAGE_MAP()


// CFileDlg message handlers
BOOL CFileDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	GetDlgItem(IDC_STC_FRABITMAP)->EnableWindow(true);
	GetDlgItem(IDC_STC_FRAME)->EnableWindow(true);
	GetDlgItem(IDC_STC_PREVIEWFRAME)->ShowWindow(SW_SHOW);
	return TRUE;
}
void CFileDlg::OnBnClickedSelectFile()
{
	LPCTSTR lpszFilter = _T("BricsCAD Drawing Files (*.dwg)|*.dwg||");
	DWORD	dwFlags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
	CString strPath = _T("");
	CFileDialog	fileDlg(TRUE, _T("dwg"), strPath, dwFlags, lpszFilter, CWnd::FromHandle(adsw_hwndAcad));
	fileDlg.m_ofn.lpstrTitle = _T("Select File"); //selects the file title;
	CAcModuleResourceOverride res;
	if (fileDlg.DoModal() != IDOK)
	{
		return;
	}
	POSITION pos(fileDlg.GetStartPosition());
	CString filename = fileDlg.GetNextPathName(pos);
	SetPreviewAsImage(filename);
	SetPreviewAsBitmap(filename);
}
void CFileDlg::SetPreviewAsImage(CString& strPath)
{
	acdbDisplayPreviewFromDwg(strPath, m_fraPreview.m_hWnd);
}
void CFileDlg::SetPreviewAsBitmap(CString& strPath)
{
	HBITMAP hBitmap;
	HPALETTE hPal;
	acdbGetPreviewBitmapFromDwg(strPath, &hBitmap, &hPal);
	CStatic* pStatic = (CStatic*)GetDlgItem(IDC_STC_PREVIEWFRAME);
	CRect oRect;
	pStatic->GetClientRect(&oRect);
	CDC *screenDC = GetDC();
	CDC mDCScreen;
	mDCScreen.CreateCompatibleDC(screenDC);
	CBitmap bitmapPreview;
	bitmapPreview.CreateCompatibleBitmap(screenDC, oRect.Width() - 10, oRect.Height() - 18);
	CImage imgPreview;
	imgPreview.Attach(hBitmap);
	CRect rect;
	double dWidth = oRect.Width();
	double dHeight = oRect.Height();
	double dAspectRatio = dWidth / dHeight;
	double dPictureWidth = imgPreview.GetWidth();
	double dPictureHeight = imgPreview.GetHeight();
	double dPictureAspectRatio = dPictureWidth / dPictureHeight;
	if (dPictureAspectRatio > dAspectRatio)
	{
		int nNewHeight = (int)(dWidth / dPictureWidth * dPictureHeight);
		int nCenteringFactor = (oRect.Height() - nNewHeight) / 2;
		rect.SetRect(0, nCenteringFactor, (int)dWidth, nNewHeight + nCenteringFactor);
	}
	else if (dPictureAspectRatio < dAspectRatio)
	{
		int nNewWidth = (int)(dHeight / dPictureHeight * dPictureWidth);
		int nCenteringFactor = (oRect.Width() - nNewWidth) / 2;
		rect.SetRect(nCenteringFactor, 0, nNewWidth + nCenteringFactor, (int)(dHeight));
	}
	CBitmap *pBitMap = mDCScreen.SelectObject(&bitmapPreview);
	CRect wndRect;
	pStatic->GetWindowRect(&wndRect);
	mDCScreen.FillSolidRect(0, 0, wndRect.Width(), wndRect.Height(), RGB(255, 255, 255));
	DWORD  dwgColor;
	dwgColor = imgPreview.GetPixel(imgPreview.GetWidth(), imgPreview.GetHeight());
	imgPreview.StretchBlt(mDCScreen.m_hDC, rect.left + 3, rect.top - 10, rect.Width() - 6, rect.Height(), 0, 0, imgPreview.GetWidth(), imgPreview.GetHeight(), SRCCOPY);
	mDCScreen.SelectObject(pBitMap);
	m_fraBitmap.SetBitmap((HBITMAP)bitmapPreview.Detach());
	ReleaseDC(screenDC);
	bitmapPreview.DeleteObject();
	DeleteObject(hBitmap);
	DeleteObject(hPal);
}
void CFileDlg::OnBnClickedBtnClose()
{
	CDialog::OnCancel();
}